; Betrieb steuert den gesamten Ablauf

.global Betrieb

Betrieb:
    mov     betsta,w0
    bra     w0
    
    bra     bet0
    bra     bet1
    bra     bet2
	bra		bet3
    
; Messungen fertig?
bet0:
    cp0     adwsta
    bra		z,bet0a
    return
; Messwerte aufbereiten
bet0a: 
	clr		w2
	btsc	PORTB,#1
	bset	w2,#0
    mov		#stromL1,w1
    call	Holemesswert
	cp0		w2
	bra		z,bet0a1
	bset	LATB,#1
	bra		bet0a2
bet0a1:
	bclr	LATB,#1
bet0a2:
	   
    clr		w2
	btsc	PORTB,#2
	bset	w2,#0
    mov		#stromL2,w1
    call	Holemesswert
	cp0		w2
	bra		z,bet0a3
	bset	LATB,#2
	bra		bet0a4
bet0a3:
	bclr	LATB,#2
bet0a4:
     
	clr		w2
	btsc	PORTB,#3
	bset	w2,#0
    mov		#stromL3,w1
    call	Holemesswert
	cp0		w2
	bra		z,bet0a5
	bset	LATB,#3
	bra		bet0a6
bet0a5:
	bclr	LATB,#3
bet0a6:

    mov		stromL1+2,wreg
    add		stromL2+2,wreg
    addc	stromL3+2,wreg
    mov		wreg,stromsumme
    inc		betsta
    return
    
; Monitor starten
bet1:
	mov		#9,w0
	cp		monsta				; Monitor auf Standby?
	bra		z,bet1a				; ja
	return
bet1a:
	mov		#4,w0
	mov		w0,monsta			; Monitor starten
	inc		betsta
	return

; Monitor fertig?
bet2:
	mov		#9,w0
	cp		monsta				; Monitor fertig?
	bra		z,bet2a				; ja
	return
; RS232 starten
bet2a:
	mov		#1,w0
	mov		w0,rssta
	inc		betsta
	return
	
; RS232 fertig?
bet3:
	cp0		rssta
	bra		z,bet3a
	return
; ADW starten
bet3a:
	mov		#6000,w0     		; 600ms
	mov		w0,adwtimer
	mov		#1,w0
	mov		w0,adwsta
; auf Standby
	clr		betsta
	return
	
; --------------- UP ---------------
 	
; Messwerte je nach Messbereich aufbereiten oder
; bei falschen Messbereich verwerfen
; Eingang: adresse in w1, w2.0 = 1 Messbereich x10
; Ausgang: adresse in w2, w2.0 = 1 erforderlicher Messbereich x10
;						  w2.0 = 0 erf. Messb, x1
Holemesswert:
	mov		[w1],w0
	cp0		w0

	btsc	w2,#0
	bra		holesw3
; Messbereich x1
	mov		#960,w0
	cp		w0,[w1]			; berlauf?
	bra		leu,holesw2		; ja, verwerfen
	
	mov		[w1+8],w3
	mov		[w1+6],w2
	mov		[w1+4],w6		; Zhler	
	call	Div32d16ist32	; W3,W2 durch W6 = W5,W4
	mov		[w1+2],w3    	; Voriger Messwert
	sub		w4,w3,w3
	inc		w3,w3
	cp		w3,#2			; 0-2 = +/-1 = nicht bernehmen
	bra		leu,holesw1		; ber 2?
	mov		w4,[w1+2]		; ja, Ausgabe
holesw1:
	clr		w2
	call	Loeschepuffer
	return
holesw2:
	call	Loeschepuffer
	bset	w2,#0
	return
	
; Messbereich x10
holesw3:
	mov		#96,w0
	cp		w0,[w1]			; zu klein?
	bra		geu,holesw5		; ja, verwerfen	
	mov		[w1+8],w3
	mov		[w1+6],w2
	mov		[w1+4],w6		; Zhler	
	call	Div32d16ist32	; W3,W2 durch W6 = W5,W4
	mov		[w1+2],w3	    	; Voriger Messwert
	sub		w4,w3,w3
	inc		w3,w3
	cp		w3,#2			; 0-2 = +/-1 = nicht bernehmen
	bra		leu,holesw4		; ber 2?
	mov		#10,w0
	mul.uu	w0,w4,w2		; Neuer Messwert
	mov		w2,[w1+2]		; Ausgabe
holesw4:
	call	Loeschepuffer
 	bset	w2,#0
	return
holesw5:
	call	Loeschepuffer
	clr		w2
	return	

; Puffer lsachen
Loeschepuffer:
	clr		w2
	mov		w2,[w1]
	mov		w2,[w1+4]
	mov		w2,[w1+6]
	mov		w2,[w1+8]
	return
	

; W3,W2 durch W6 = W5,W4
; 41 Cycle x 34ns = ca. 1,4us
; Register: W0 bis W6
Div32d16ist32:
	cp0		w6
	bra		nz,div0
	mov		#0xffff,w4
	mov		#0xffff,w5
	return
div0:
	push	w1
	repeat	#17
	div.u	w3,w6			; w3 : w6 = w0, rest w1
nop
	mov		w0,w5 
	mov		w1,w3
	repeat	#17		
	div.ud	w2,w6			; w3,w2 : w6 = w0, rest in w1
nop
	mov		w0,w4
	pop		w1
	return
	
	
    
		    