; Monitor verwaltet die Texte / Daten der LCD-Anzeige

.global Monitor,Zeile1
.text

Monitor:
	mov		lcdsta,w0
	cp0		w0
	bra		z,monitorv		; LCDout frei?
	return                  ; nein
monitorv:
	mov		monsta,w0
	bra		w0
  	bra		monitor0
	bra		monitor1
	bra		monitor2
	bra		monitor3
	bra		monitor4
	bra		monitor5
	bra		monitor6
	bra		monitor7
	bra		monitor8 
	bra		monitor9 

; nach Reset: Text fr Zeile 1 bis 4
monitor0:
	call	Zeile1zumlcd
	bra		monitornext
monitor1:
	call	Zeile2zumlcd
	bra		monitornext
monitor2:
	call	Zeile3zumlcd
	bra		monitornext
monitor3:
	call	Zeile4zumlcd
	bra		monitornext
			
; variable Werte zum LCD
monitor4:
	call	Wert1zumlcd
	bra		monitornext
monitor5:
	call	Wert2zumlcd
	bra		monitornext
monitor6:
	call	Wert3zumlcd
	bra		monitornext
monitor7:
	call	Wertsummezumlcd
	bra		monitornext
monitor8:
	call	Messwert50hz
	bra		monitornext

; warten bis neue Werte fertig sind
monitor9:
	return
	
; -----------------------------
; Ausgnge
; -----------------------------

monitornext:
	mov		#lcdpuffer,w0
	mov		w0,lcdzgr
	mov		#1,w0
	mov		w0,lcdsta		; LCDout starten
	inc		monsta
 	Return

; -----------------------------
; div. UPs
; -----------------------------

; FixTexte zum LCD
Zeile1zumlcd:
	mov		#lcdpuffer,w1
	mov		#psvoffset(Zeile1),w0
	bra		zeilexzumlcd
Zeile2zumlcd:
	mov		#lcdpuffer,w1
	mov		#psvoffset(Zeile2),w0
	bra		zeilexzumlcd
Zeile3zumlcd:
	mov		#lcdpuffer,w1
	mov		#psvoffset(Zeile3),w0
	bra		zeilexzumlcd	
Zeile4zumlcd:
	mov		#lcdpuffer,w1
	mov		#psvoffset(Zeile4),w0
zeilexzumlcd:
	do		#11,zeilexzumlcda
	mov		[w0],w2
	and		#0x00ff,w2
	mov		w2,[w1++]
	mov		[w0++],w2
	swap	w2
	and		#0x00ff,w2
zeilexzumlcda:
	mov		w2,[w1++]
	return

; Variable Texte zum LCD

Wert1zumlcd:
	mov		#0x8f,w0
	mov		w0,lcdpuffer
	mov		stromL1+2,w0
	bra		wertxzumlcd
Wert2zumlcd:
	mov		#0xcf,w0
	mov		w0,lcdpuffer
	mov		stromL2+2,w0
	bra		wertxzumlcd
Wert3zumlcd:
	mov		#0xa3,w0
	mov		w0,lcdpuffer
	mov		stromL3+2,w0
wertxzumlcd:
	call	Bin16asc5		; w0 > w4,w3,w2,w1,w0
	call	Entfernenullen
	mov		w3,lcdpuffer+2
	mov		w2,lcdpuffer+4
	mov		w1,lcdpuffer+6
	mov		w0,lcdpuffer+8
	clr		lcdpuffer+10
	return

Wertsummezumlcd:
	mov		#0xe2,w0
	mov		w0,lcdpuffer
	mov		stromsumme,w0
	call	Bin16asc5		; w0 > w4,w3,w2,w1,w0
	call	Entfernenullen
	mov		w4,lcdpuffer+2
	mov		w3,lcdpuffer+4
	mov		w2,lcdpuffer+6
	mov		w1,lcdpuffer+8
	mov		w0,lcdpuffer+10
	clr		lcdpuffer+12
	return

Messwert50hz:
	mov		#0xd8,w0
	mov		w0,lcdpuffer
	disi	#2
	mov		w14,w5
	mov		w13,w4
	mov		#0x6808,w0		; Quarz 8,00205 MHz
	sub		w4,w0,w4
	mov		#0x1e8,w0
	subb	w5,w0,w5
	btss	w5,#15		; neg?
	bra		mwzlcd1		; nein
	com		w5,w5
	com		w4,w4
	add		#1,w4
	addc	#0,w5
	mov		#'+',w0
	bra		mwzlcd2
mwzlcd1:
	mov		#'-',w0
mwzlcd2:
	mov		w0,mw50hz+8
	mov		w0,lcdpuffer+2
	mov		#320,w2
	repeat	#17
	div.ud	w4,w2			; w5,w4 : w2 = W0, Rest in W1
	call	Bin16asc5		; w0 > w4,w3,w2,w1,w0
	mov		w3,lcdpuffer+4
	mov		w2,lcdpuffer+6
	mov		w1,lcdpuffer+8
	mov		w0,lcdpuffer+10
	clr		lcdpuffer+12
	mov		w3,mw50hz
	mov		w2,mw50hz+2
	mov		w1,mw50hz+4
	mov		w0,mw50hz+6
	return	
	
	
; FixTexte
Zeile1:
	.ascii	<0x80>,"StKe LiKu StKu 1234W",<0>
Zeile2:
	.ascii	<0xc0>,"StUn StGa StOb 1234W",<0>
Zeile3:
	.ascii	<0x94>,"LiUn LiOb      1234W",<0>
Zeile4:
 	.ascii	<0xd4>,"50Hz-0123mHz  12345W",<0>
